#Module-Specific definitions
%define mod_name mod_spin
%define mod_conf A65_%{mod_name}.conf
%define mod_so %{mod_name}.so

%define	major 1
%define libname %mklibname rxv_spin %{major}
%define develname %mklibname rxv_spin -d

Summary:	Simple template language with data replacement capabilities for Apache
Name:		apache-%{mod_name}
Version:	1.1.9
Release:	%mkrel 2
Group:		System/Servers
License:	GPL
URL:		http://www.rexursive.com/software/modspin/
Source0:	ftp://ftp.rexursive.com/pub/mod-spin/%{mod_name}-%{version}.tar.bz2
Source1:	%{mod_conf}
Patch0:		mod_spin-no_strip.diff
Patch1:		mod_spin-borked_docs.diff
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.2.0
Requires(pre):	apache >= 2.2.0
Requires:	apache-conf >= 2.2.0
Requires:	apache >= 2.2.0
Requires:	apache-mod_unique_id >= 2.2.0
BuildRequires:  apache-devel >= 2.2.0
BuildRequires:	autoconf2.5
BuildRequires:	bison
BuildRequires:	doxygen
BuildRequires:	file
BuildRequires:	flex >= 2.5.33
BuildRequires:	libapreq-devel >= 2.07
BuildRequires:	libtool
BuildRequires:	libxml2-devel
BuildRequires:	mysql-devel
BuildRequires:	postgresql-devel
BuildRequires:	tetex-latex
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
mod_spin is an Apache module that provides (in conjunction with some other
modules) a simple template language with data replacement capabilities only,
persistent application and session data tracking, dynamic linking of
applications into Apache 2 as shared libraries, parameters, cookies and
multipart/form data parsing via libapreq2, simple API for (kind of) MVC
controller functionality and simple API for pooled (or not) access to SQL
databases.

%package -n	%{libname}
Summary:	Shared libraries for %{name}
Group:          System/Libraries

%description -n	%{libname}
Shared libraries for %{name}

%package -n	%{develname}
Summary:	Development library and header files for the %{name} library
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}
Provides:	librxv_spin-devel = %{version}
Provides:	%{mklibname rxv_spin 0 -d} = %{version}-%{release}
Obsoletes:	%{mklibname rxv_spin 0 -d}

%description -n	%{develname}
This package contains the static %{libname} library and its header
files.

%prep

%setup -q -n %{mod_name}-%{version}
%patch0 -p0
%patch1 -p0

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type d -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

for i in `find . -type d -name CVS` `find . -type d -name .svn` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -r $i; fi >&/dev/null
done

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find . -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

cp %{SOURCE1} %{mod_conf}

%build
rm -rf configure autom4te.cache
libtoolize --copy --force --automake; aclocal -I m4; autoheader; automake --add-missing --copy; autoconf

export STRIP="/bin/false"

%configure2_5x --localstatedir=/var/lib \
    --enable-packager \
    --with-pgsql \
    --with-mysql \
    --with-flex-reentrant=%{_prefix} \
    --libexecdir="`%{_sbindir}/apxs -q LIBEXECDIR`-extramodules"

make -C src

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_sysconfdir}/httpd/modules.d

%makeinstall_std

# fix apache dir
mv %{buildroot}%{_libdir}/apache %{buildroot}%{_libdir}/apache-extramodules

# apache config
install -m0644 %{mod_conf} %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_conf}

# lib64 fix
perl -pi -e "s|/lib\b|/%{_lib}|g" %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_conf}

# fix docs
rm -rf html_docs
cp -rp docs/html html_docs
chmod 644 html_docs/*
rm -f html_docs/installdox

# cleanup
rm -f %{buildroot}%{_libdir}/apache-extramodules/*.*a
rm -rf %{buildroot}%{_docdir}/%{mod_name}-%{version}

%post
if [ -f /var/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif

%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc html_docs/* docs/mod_spin.pdf create-store-mysql.sql create-store.sql
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_so}

%files -n %{libname}
%defattr(-,root,root)
%attr(0755,root,root) %{_libdir}/*.so.%{major}*

%files -n %{develname}
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/rxv_spin-config
%attr(0755,root,root) %{_libdir}/*.a
%attr(0644,root,root) %{_libdir}/*.la
%attr(0755,root,root) %{_libdir}/*.so
%{_includedir}/*
%{_datadir}/aclocal/*.m4
%{_libdir}/pkgconfig/mod_spin.pc
%{_mandir}/man3/*


%changelog
* Sat Aug 01 2009 Oden Eriksson <oeriksson@mandriva.com> 1.1.9-2mdv2010.0
+ Revision: 406654
- rebuild

* Sun Jun 21 2009 Oden Eriksson <oeriksson@mandriva.com> 1.1.9-1mdv2010.0
+ Revision: 387728
- 1.1.9
- rediffed patches

* Wed Jan 07 2009 Oden Eriksson <oeriksson@mandriva.com> 1.1.8-2mdv2009.1
+ Revision: 326504
- rebuild

* Fri Aug 15 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1.8-1mdv2009.0
+ Revision: 272272
- 1.1.8

* Mon Jul 14 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1.7-5mdv2009.0
+ Revision: 235105
- rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Thu Jun 05 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1.7-4mdv2009.0
+ Revision: 215643
- fix rebuild
- hard code %%{_localstatedir}/lib to ease backports

* Sun Mar 09 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1.7-3mdv2008.1
+ Revision: 182868
- rebuild

* Thu Feb 14 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.1.7-2mdv2008.1
+ Revision: 168481
- rebuild
- fix summary

* Wed Dec 26 2007 Oden Eriksson <oeriksson@mandriva.com> 1.1.7-1mdv2008.1
+ Revision: 138119
- 1.1.7

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Tue Oct 23 2007 Oden Eriksson <oeriksson@mandriva.com> 1.1.6-1mdv2008.1
+ Revision: 101461
- 1.1.6

* Sat Sep 08 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.12-3mdv2008.0
+ Revision: 82679
- rebuild


* Sat Mar 10 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.12-2mdv2007.1
+ Revision: 140758
- rebuild

* Wed Feb 14 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.12-1mdv2007.1
+ Revision: 121009
- 1.0.12

* Thu Dec 21 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.11-1mdv2007.1
+ Revision: 101078
- 1.0.11
- bunzip the config file
- fix deps (flex)

* Thu Nov 09 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.10-3mdv2007.0
+ Revision: 79517
- Import apache-mod_spin

* Tue Sep 05 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.10-1mdv2007.0
- rebuilt against MySQL-5.0.24a-1mdv2007.0 due to ABI changes

* Mon Jul 03 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.10-2mdv2007.0
- fix a silly typo in the config (S1)

* Fri Jun 30 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.1-1mdk
- initial Mandriva package

